org.apache.tinkerpop.gremlin.process.traversal.step.util

## Class SupplyingBarrierStep<S,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.SupplyingBarrierStep<S,E>

- All Implemented Interfaces:
    Serializable, Cloneable, Iterator<Traverser.Admin<E>>, Step<S,E>, Barrier<Boolean>, MemoryComputing<Boolean>
  Direct Known Subclasses:
    SideEffectCapStep

      public abstract class SupplyingBarrierStep<S,E>
      extends AbstractStep<S,E>
      implements Barrier<Boolean>

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SupplyingBarrierStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addBarrier(Boolean barrier)` Add a barrier to the step.
    `void` | `addStart(Traverser.Admin<S> start)` Add a single `Traverser.Admin` to the step.
    `void` | `addStarts(Iterator<Traverser.Admin<S>> starts)` Add a iterator of `Traverser.Admin` objects of type S to the step.
    `SupplyingBarrierStep<S,E>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `void` | `done()` A way to hard set that the barrier is complete.
    `MemoryComputeKey<Boolean>` | `getMemoryComputeKey()` The `MemoryComputeKey` that will be used by this step.
    `boolean` | `hasNextBarrier()` Whether or not the step has an accessible barrier.
    `Boolean` | `nextBarrier()` Get the next barrier within this step.
    `void` | `processAllStarts()` Process all left traversers by do not yield the resultant output.
    `Traverser.Admin<E>` | `processNextStart()`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `protected abstract E` | `supply()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hashCode, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep, setTraversal, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals, getRequirements`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### SupplyingBarrierStep

          public SupplyingBarrierStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### supply

          protected abstract E supply()

    - #### addStarts

          public void addStarts(Iterator<Traverser.Admin<S>> starts)

      Description copied from interface: `Step`
      Add a iterator of `Traverser.Admin` objects of type S to the step.
      Specified by:
        `addStarts` in interface `Step<S,E>`
      Overrides:
        `addStarts` in class `AbstractStep<S,E>`
      Parameters:
        `starts` - The iterator of objects to add

    - #### addStart

          public void addStart(Traverser.Admin<S> start)

      Description copied from interface: `Step`
      Add a single `Traverser.Admin` to the step.
      Specified by:
        `addStart` in interface `Step<S,E>`
      Overrides:
        `addStart` in class `AbstractStep<S,E>`
      Parameters:
        `start` - The traverser to add

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,E>`
      Overrides:
        `reset` in class `AbstractStep<S,E>`

    - #### processNextStart

          public Traverser.Admin<E> processNextStart()

      Specified by:
        `processNextStart` in class `AbstractStep<S,E>`

    - #### clone

          public SupplyingBarrierStep<S,E> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,E>`
      Overrides:
        `clone` in class `AbstractStep<S,E>`
      Returns:
        The cloned step

    - #### processAllStarts

          public void processAllStarts()

      Description copied from interface: `Barrier`
      Process all left traversers by do not yield the resultant output. This method is useful for steps like `ReducingBarrierStep`, where traversers can be processed "on the fly" and thus, reduce memory consumption.
      Specified by:
        `processAllStarts` in interface `Barrier<Boolean>`

    - #### hasNextBarrier

          public boolean hasNextBarrier()

      Description copied from interface: `Barrier`
      Whether or not the step has an accessible barrier.
      Specified by:
        `hasNextBarrier` in interface `Barrier<Boolean>`
      Returns:
        whether a barrier exists or not

    - #### nextBarrier

          public Boolean nextBarrier()
                              throws NoSuchElementException

      Description copied from interface: `Barrier`
      Get the next barrier within this step. Barriers from parallel steps can be the be merged to create a single step with merge barriers.
      Specified by:
        `nextBarrier` in interface `Barrier<Boolean>`
      Returns:
        the next barrier of the step
      Throws:
        `NoSuchElementException`

    - #### addBarrier

          public void addBarrier(Boolean barrier)

      Description copied from interface: `Barrier`
      Add a barrier to the step. This typically happens when multiple parallel barriers need to become one barrier at a single step.
      Specified by:
        `addBarrier` in interface `Barrier<Boolean>`
      Parameters:
        `barrier` - the barrier to merge in

    - #### done

          public void done()

      Description copied from interface: `Barrier`
      A way to hard set that the barrier is complete. This is necessary when parallel barriers don't all have barriers and need hard resetting. The default implementation does nothing.
      Specified by:
        `done` in interface `Barrier<Boolean>`

    - #### getMemoryComputeKey

          public MemoryComputeKey<Boolean> getMemoryComputeKey()

      Description copied from interface: `MemoryComputing`
      The `MemoryComputeKey` that will be used by this step.
      Specified by:
        `getMemoryComputeKey` in interface `MemoryComputing<Boolean>`
      Returns:
        the MemoryComputeKey to use

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.